/**
* @par Copyright (C): 2010-2019, Shenzhen Yahboom Tech
* @file         PS2_control.c
* @author       Danny
* @version      V1.0
* @date         2017.08.16
* @brief        PS2ֱСۺʵ
* @details
* @par History  ˵
*
*/

#include "STC12C5A60S2.h"
#include "stdio.h"
#include "ps2.h"

#define ON 1     //ʹLED
#define OFF 0    //ֹLED
													
//
sbit Left_motor_go=P2^1;	   //ǰAIN2
sbit Left_motor_back=P2^2;	   //AIN1
sbit Right_motor_go=P2^4;	   //ҵǰBIN2
sbit Right_motor_back=P2^3;	   //ҵBIN1
sbit Left_motor_pwm=P2^0;	   //PWMA
sbit Right_motor_pwm=P2^5;	   //ҵPWMB

unsigned char pwm_val_left  =0; //
unsigned char pwm_val_right =0;

//ٶȵڱ 0-200,0С,200
unsigned char push_val_left =150;  // ռձpush_val_left/200 
unsigned char push_val_right=150;  // ҵռձpush_val_right/200 

//Ŷ
sbit FM=P2^7;

//
sbit ServoPin=P0^5;


//ʱ
int servocount=0;

//Ƕֵ
int myangle = 0;

//RGB߲ʵ
sbit LED_R = P4^6;	//LED_RSTC12C5A60S2EAP4^6ܽ
sbit LED_G = P4^5;  //LED_GSTC12C5A60S2ALEP4^5ܽ
sbit LED_B = P4^4;	//LED_BSTC12C5A60S2PSENP4^4ܽ

//ٿ			  
bit Left_PWM_ON=1;
bit Right_PWM_ON=1;

//ʱСٶȣС״̬
unsigned char  time; 		 
int g_carstate = 0;
int g_ServoState = 0;     //1ҡ 2 ҡ
//Сٶȵλ
int g_volume = 0;

//С״̬ö
enum{
  	enSTOP = 0,
  	enRUN,
  	enBACK,
  	enLEFT,
  	enRIGHT,
  	enUPLEFT,
  	enUPRIGHT,
  	enDOWNLEFT,
  	enDOWNRIGHT,
  	enSPINLEFT,
  	enSPINRIGHT
}enCarState;

//궨ٶȵλ
#define 	enMinMin() do{\
                       push_val_left =50; \
					   push_val_right =50;\
					   }while(0)

#define 	enMin() do{\
                       push_val_left =100; \
					   push_val_right =100;\
					   }while(0)

#define 	enMidle() do{\
                       push_val_left =150; \
					   push_val_right =150;\
					   }while(0)

#define 	enMax() do{\
                       push_val_left =200; \
					   push_val_right =200;\
					   }while(0)
					   					   
/**
* Function       delay
* @author        Danny
* @date          2017.08.16
* @brief         ʱ
* @param         xmsʱʱ䣨ms
* @retval        void
* @par History   
*/	
void delay(unsigned int xms)				
{
    unsigned int i,j;
	for(i=xms;i>0;i--)		      
    for(j=850;j>0;j--);
}

/**
* Function       pwm_out_left_motor
* @author        Danny
* @date          2017.08.16
* @brief         	,push_val_leftֵıת,ռձ
* @param         void
* @retval        void
* @par History   
*/                         
void pwm_out_left_motor(void)		
{  
     if(Left_PWM_ON)
     {
          if(pwm_val_left<=push_val_left)
	      {
	          Left_motor_pwm =1; 
	      }
	      else 
	      {
	           Left_motor_pwm=0;
          }
          if(pwm_val_left>=200) //200pwmΪ20ms50hz
	      pwm_val_left=0;
     }
     else    
     {
          Left_motor_pwm=0;   //δPWMPWMA=0 ֹͣ
     }
}


/**
* Function       pwm_out_right_motor
* @author        Danny
* @date          2017.08.16
* @brief         ҵ	,pwm_val_rightֵıת,ռձ
* @param         void
* @retval        void
* @par History   
*/
void pwm_out_right_motor(void)		  
{ 
    if(Right_PWM_ON)
    { 
        if(pwm_val_right<=push_val_right)	
	    {
	        Right_motor_pwm=1; 							
        }
	    else 
	    {
	        Right_motor_pwm=0;
        }
	    if(pwm_val_right>=200) //200pwmΪ20ms50hz
	    pwm_val_right=0;
    }
    else    
    {
        Right_motor_pwm=0;	  //δPWMPWMB=0ҵֹͣ
    }
}

  /**
* Function       servo_appointed_detection
* @author        Danny
* @date          2017.08.16
* @brief         תָǶ
* @param[in]     posָĽǶ
* @param[out]    void
* @retval        void
* @par History   
*/
void servo_appointed_detection(int pos)
{
	int i = 0;
  	for (i = 0; i <= 15; i++) //PWMЧʱԱ֤תӦǶ
  	{
    	myangle = pos;          //ģPWM
		delay(20);
 	}
}

/**
* Function       run
* @author        Danny
* @date          2017.08.16
* @brief         Сǰ
* @param[in1]    time :ʱʱ
* @param[out]    void
* @retval        void
* @par History   
*/
void run(unsigned int time)
{
  	//ǰ
  	Left_motor_go = 1;   //ǰʹ
  	Left_motor_back = 0; //˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-200
 	// push_val_left=CarSpeed;
	 
  	//ҵǰ
  	Right_motor_go=1;   //ҵǰʹ
  	Right_motor_back=0; //ҵ˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-200
  	//push_val_right=CarSpeed;
  
  	//ʱ
  	delay(time * 100);
  	return;
}

/**
* Function       brake
* @author        Danny
* @date          2017.08.16
* @brief         Сɲ
* @param[in]     time
* @param[out]    void
* @retval        void
* @par History   
*/
void brake(unsigned int time)
{
  	//ֹͣ
  	Left_motor_go = 0;   //ǰֹ
  	Left_motor_back = 0; //˽ֹ
	 
  	//ҵֹͣ
  	Right_motor_go=0;   //ҵǰֹ
 	Right_motor_back=0;  //ҵ˽ֹ
 
  	//ʱ
  	delay(time * 100);
  	return;
}

/**
* Function       left
* @author        Danny
* @date          2017.08.16
* @brief         Сת ת(ֲ,ǰ)
* @param[in]     time :ʱʱ
* @param[out]    void
* @retval        void
* @par History   
*/
void left(unsigned int time)
{
  	//ֹͣ
  	Left_motor_go = 0;   //ǰֹ
  	Left_motor_back = 0;   //˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-200
 	// push_val_left=0;
  	 
  	//ҵǰ
  	Right_motor_go=1;   //ҵǰʹ
  	Right_motor_back=0;  //ҵ˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-200
  	//push_val_right=CarSpeed;

  	//ʱ
  	delay(time * 100);
  	return;
}

/**
* Function       right
* @author        Danny
* @date          2017.08.16
* @brief         Сת ת(ǰ,ֲ)
* @param[in]     time:ʱʱ
* @param[out]    void
* @retval        void
* @par History   
*/
void right(unsigned int time)
{
  	//ǰ
  	Left_motor_go = 1;   //ǰʹ
  	Left_motor_back = 0;   //˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	//push_val_left=CarSpeed;
	 
  	//ҵֹͣ
  	Right_motor_go=0;   //ҵǰֹ
  	Right_motor_back=0;  //ҵ˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	push_val_right=0;

  	//ʱ
  	delay(time * 100);  
  	return;
}

/**
* Function       spin_left
* @author        Danny
* @date          2017.08.16
* @brief         Сԭת ԭת(ֺˣǰ)
* @param[in]     time:ʱʱ
* @param[out]    void
* @retval        void
* @par History   
*/
void spin_left(unsigned int time)
{
  	//
  	Left_motor_go = 0;   //ǰֹ
  	Left_motor_back = 1;   //ʹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
 	// push_val_left=CarSpeed;
	 
  	//ҵǰ
  	Right_motor_go=1;   //ҵǰʹ
  	Right_motor_back=0;  //ҵ˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
 	// push_val_right=CarSpeed;

  	//ʱ
  	delay(time * 100);  
  	return;
}

/**
* Function       spin_right
* @author        Danny
* @date          2017.08.16
* @brief         Сԭת ԭת(ֺˣǰ)
* @param[in]     time:ʱʱ
* @param[out]    void
* @retval        void
* @par History   
*/
void spin_right(unsigned int time)
{
  	//ǰ
  	Left_motor_go = 1;   //ǰʹ
  	Left_motor_back = 0;  //˽ֹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	//push_val_left=CarSpeed;
	 
  	//ҵ
  	Right_motor_go=0;   //ҵǰֹ
  	Right_motor_back=1;  //ҵʹ
  	//ָܽŵPWMֵĿʵֿ٣0-20
  	//push_val_right=CarSpeed;

  	//ʱ
  	delay(time * 100);  
  	return;
}

/**
* Function       up_right
* @author        Danny
* @date          2017.08.16
* @brief         СϷת
* @param[in]     time:ʱʱ
* @param[out]    void
* @retval        void
* @par History   
*/
void up_right(unsigned int time)        //
{
	Left_motor_go=1;
	Left_motor_back=0;
	//push_val_left=CarSpeed+50;
	push_val_left=18;

	Right_motor_go=1;
	Right_motor_back=0;
	//push_val_right=CarSpeed;
	push_val_right=10;
    //ʱ
    delay(time * 100);
    return;
}

/**
* Function       down_right
* @author        Danny
* @date          2017.08.16
* @brief         С·ת
* @param[in]     time:ʱʱ
* @param[out]    void
* @retval        void
* @par History   
*/
void down_right(unsigned int time)  //
{	
	Left_motor_go=0;
	Left_motor_back=1;
	//push_val_left=CarSpeed+50;
    push_val_left=18;
	Right_motor_go=0;
	Right_motor_back=1;
	//push_val_right=CarSpeed;
	push_val_right=10;
	delay(time * 100);
	return;
}

/**
* Function       up_left
* @author        Danny
* @date          2017.08.16
* @brief         СϷת
* @param[in]     time:ʱʱ
* @param[out]    void
* @retval        void
* @par History   
*/
void up_left(unsigned int time)	  
{
   	Left_motor_go=1;
	Left_motor_back=0;
	//push_val_left=CarSpeed;
	push_val_left=10;
	Right_motor_go=1;
	Right_motor_back=0;
	//push_val_right=CarSpeed+50;
	push_val_right=18;
	delay(time * 100);
    return;
}

/**
* Function       down_left
* @author        Danny
* @date          2017.08.16
* @brief         С·ת
* @param[in]     time :ʱʱ
* @param[out]    void
* @retval        void
* @par History   
*/
void down_left(unsigned int time)	
{
   	Left_motor_go=0;
	Left_motor_back=1;
	//push_val_left=CarSpeed;
	push_val_left=10;
	Right_motor_go=0;
	Right_motor_back=1;
	//push_val_right=CarSpeed+50;
	push_val_right=18;
	delay(time * 100);
	return;
}

/**
* Function       back
* @author        Danny
* @date          2017.08.16
* @brief         С 
* @param[in]     time ʱʱ
* @param[out]    void
* @retval        void
* @par History   
*/
void back(unsigned int time)
{
  	//
  	Left_motor_go = 0;   //ǰֹ
  	Left_motor_back = 1; //ʹ
	 
  	//ҵ
  	Right_motor_go=0;    //ҵǰֹ
  	Right_motor_back=1;  //ҵʹ
  
  	//ʱ
  	delay(time * 100);
  	return;
}

/**
* Function       timer0
* @author        Danny
* @date          2017.08.16
* @brief         TIMER0жϷӺPWMźţڿƵٶȺͿƶת
* @param[in]     void
* @param[out]    void
* @retval        void
* @par History   
*/
void timer0()interrupt 1 
{
	int PulseWidth;
    TH0=0Xff;	      //100usʱ
	TL0=0Xa4;
	servocount++;
	 	             	               //
    PulseWidth = ((myangle*11)+500)/100 ;  //Ϊ˽0-180תΪӦֵ
    if(servocount == PulseWidth)
    {
		ServoPin=0;                //ӿڵƽø
    }	           
    if(servocount == 190)		   //190ΪյԻõһֵ
    {
    	servocount = 0;
        ServoPin=1;                //ӿڵƽõ
    }
	pwm_val_left++;
	pwm_val_right++;
	pwm_out_left_motor();
	pwm_out_right_motor();
}

/**
* Function       TIME0_Init
* @author        Danny
* @date          2017.08.16
* @brief         ʱ0ʼ
* @param[in]     void
* @param[out]    void
* @retval        void
* @par History   
*/
void TIME0_Init(void)
{
	TMOD |=0X01;	//ʱʽ1
	TH0= 0Xff;      //100Usʱ
    TL0= 0Xa4;
	TR0= 1;		    //T0
	ET0= 1;		    //T0ж
	EA = 1;	        //ж
}

/**
* Function       color_led
* @author        Danny
* @date          2017.08.16
* @brief         R,G,BɫĲͬγ7ֲͬɫ
* @param[in1]    Red
* @param[in2]    Green
* @param[in3]    Blue
* @retval        void
* @par History   
*/
void color_led(int v_iRed, int v_iGreen, int v_iBlue)
{
  	//ɫLED
  	v_iRed == ON ? (LED_R = 1): (LED_R = 0);
 
  	//ɫLED
  	v_iGreen == ON ? (LED_G = 1): (LED_G = 0);
  
  	//ɫLED
  	v_iBlue == ON ? (LED_B = 1): (LED_B = 0);
}


/**
* Function       UartInit
* @author        Danny
* @date          2017.08.16
* @brief         ڳʼ
*                ʱʽ2
*                ʵֵԶأʵļΪ
*                (2SMODη/32)*(sysclk(ƬڲʱƵ)/12)/(256-TH1)
                 (ϵͳĬµSMOD0T1X12ҲΪ0)
				 1/32*((11059200/12)/(256-FD))=9600 
* @param[in]     void
* @retval        void
* @par History   
*/

void UartInit(void)   
{
    SCON|=0x50;  	 //пڹڷʽ1н
    TMOD|=0x20;		 //ʱ1ʽ2ԶسֵTL1ʼֵTH1ֵ
    TH1=0xfd;		 //ʼΪ9600
	TL1=0xfd;
    TI=1;			 //ͱ־λ1ʾһֽ
    TR1=1;			 //ʱ1ʼ
}

/**
* Function       PS2_control
* @author        Danny
* @date          2017.07.25
* @brief         PS2С
* @param[in]     void
* @param[out]    void
* @retval        void
* @par History   
*/
void PS2_control()
{
	//PS2
	stPS2KeyValue * PS2;
    	
	PS2 = ReadPS2KeyValue();	    //ֱ֮õֵ
	//data[3]data[4]ϳ16λ
	//data[4]data[3]:selectʱ
	//FunBtn0x1111 1111 1111 1110
	if((PS2->FunBtn & PSB_SELECT) == 0)
	{
		 printf("PSB_SELECT!\n");
	}
		
	if((PS2->FunBtn & PSB_START) == 0)
	{
		 printf("PSB_START!\n");
	}
		 
	if((PS2->FunBtn & PSB_L3) == 0)
	{
		printf("PSB_L3!\n");
		g_carstate = enSTOP;      //СΪֹͣ״̬
	}

	if((PS2->FunBtn & PSB_R3) == 0)
	{
		printf("PSB_R3!\n");
		g_carstate = enSTOP;      //СΪֹͣ״̬
	}

	if((PS2->FunBtn & PSB_PAD_UP) == 0)
	{
		printf("PSB_PAD_UP!\n");
		g_carstate = enRUN;       //СΪǰ״̬
	}

	else if((PS2->FunBtn & PSB_PAD_RIGHT) == 0)
	{
		printf("PSB_PAD_RIGHT!\n");
		g_carstate = enRIGHT;     //СΪ״̬ת
	}
	else if((PS2->FunBtn & PSB_PAD_DOWN) == 0)
	{
		printf("PSB_PAD_DOWN!\n");
		g_carstate = enBACK;       //СΪ״̬
	}
	else if((PS2->FunBtn & PSB_PAD_LEFT) == 0)
	{
		printf("PSB_PAD_LEFT!\n");
		g_carstate = enLEFT;       //СΪת״̬
	}
	   
	else                           //ȥһֱִУӴ˶ſֹͣ
	{
		 g_carstate = enSTOP;        //СΪֹͣ״̬
	}
		  
 	if((PS2->FunBtn & PSB_L2) == 0)			 //
	{
		printf("PSB_L2!\n");
		//CarSpeed=CarSpeed+40;
		//if(CarSpeed>=200)                       
		//{
		//	  CarSpeed = 200;
		//}
        g_volume++;
		if(g_volume>=4)                          //ٶĸȼ
		{
			g_volume = 4;
		}
	}
		 
	if((PS2->FunBtn & PSB_R2) == 0)			 //
	{
		printf("PSB_R2!\n");
		//CarSpeed=CarSpeed-40;
		//if(CarSpeed<0)                       
		//{
        //    CarSpeed = 50;
        //}
		g_volume--;
		if(g_volume <= 0)
		{
			g_volume = 1;
		}
	} 
		//ֱL1ºҡݣX1Y1֮
		//ҡ˿С״̬	 		
	if((PS2->FunBtn & PSB_L1) == 0)
	{
		printf("PSB_L1!\n"); 
			 
		if (PS2->Y1 < 5 && PS2->X1 > 80 && PS2->X1 < 180) //
		{
			g_carstate = enRUN;
			printf("enRUN\n");
		}
		else if (PS2->Y1 > 230 && PS2->X1 > 80 && PS2->X1 < 180) //
		{
			g_carstate = enBACK;
			printf("enBACK\n");
		}
		else if (PS2->X1 < 5 && PS2->Y1 > 80 && PS2->Y1 < 180) //
		{
		     g_carstate = enLEFT;
			 printf("enLEFT\n");
		}
		else if (PS2->Y1 > 80 && PS2->Y1 < 180 && PS2->X1 > 230)//
		{
		      g_carstate = enRIGHT;
			  printf("enRIGHT\n");
		}
		else if (PS2->Y1 <= 80 && PS2->X1 <= 80) //
		{
		      g_carstate = enUPLEFT;
			  printf("enUPLEFT\n");
		}
		else if (PS2->Y1 <= 80 && PS2->X1 >= 180) //
		{
		      g_carstate = enUPRIGHT;
			  printf("enUPRIGHT\n");
		}
		else if (PS2->X1 <= 80 && PS2->Y1 >= 180) // 
		{
		      g_carstate = enDOWNLEFT;
			  printf("enDOWNLEFT\n");
		}
		else if (PS2->Y1 >= 180 && PS2->X1 >= 180) //
		{
		      g_carstate = enDOWNRIGHT;
			  printf("enDOWNRIGHT\n");
		}
		else//ͣ
		{
		      g_carstate = enSTOP;
		}
	} 
	//R1֮Ҳҡʱ
	//Ҳҡ˿СĶ״̬
	if((PS2->FunBtn & PSB_R1) == 0)
	{
		printf("PSB_R1!\n"); 
		//ҡ
		if (PS2->X2 < 5 && PS2->Y2 > 80 && PS2->Y2 < 180)    //
        {
			g_ServoState = 1;
		}
		else if (PS2->Y2 > 80 && PS2->Y2 < 180 &&PS2->X2 > 230)//
        {
			g_ServoState = 2;
        }
        else                                      //λ
        {
             g_ServoState = 0;
        }
	}        
		       
	if((PS2->FunBtn & PSB_TRIANGLE) == 0) // Ƶ
	{
		printf("PSB_TRIANGLE!\n");
		color_led(ON, OFF, ON);
		// ReadPS2KeyValue();
	} 
		 
	if((PS2->FunBtn & PSB_CIRCLE) == 0)	// 
	{
		printf("PSB_CIRCLE!\n");
		g_carstate = enLEFT;  
		// ReadPS2KeyValue();
	}  
	
	if((PS2->FunBtn & PSB_CROSS) == 0) // 
	{
		printf("PSB_CROSS!\n");
		FM = 0;
		delay(500);
		FM = 1;
		//	ReadPS2KeyValue();
	} 
		 
	if((PS2->FunBtn & PSB_SQUARE) == 0)	  //
	{
		printf("PSB_SQUARE!\n");
		g_carstate = enRIGHT; 
		// ReadPS2KeyValue();
	}
}


/**
* Function       main
* @author        Danny
* @date          2017.08.16
* @brief         
* @param[in]     void
* @retval        void
* @par History   
*/
void main()
{
	int flag=0;
	int g_oldcarstate=20;
	UartInit();				//ڳʼ	
	TIME0_Init();			//ʱ0ʼ
	PS2_Init();				//PS2ʼ

    //ųʼΪߵƽ
  	ServoPin=1;
	
	//ʼλǰ
    servo_appointed_detection(90);

    //P4ΪͨIOʹ
    P4SW |= (1<<4);
    P4SW |= (1<<5);
    P4SW |= (1<<6);

	//P4Ϊǿģʽ
	P4M1 &= ~(1<<4); 
	P4M1 &= ~(1<<5);
	P4M1 &= ~(1<<6);

   	P4M0 |= (1<<4);
   	P4M0 |= (1<<5);
   	P4M0 |= (1<<6);

	color_led(OFF, OFF, OFF);
	while(1)	
	{ 
	    PS2_control();
		  		           
		//С״̬ӦĶ
	    if(g_carstate != g_oldcarstate)
		{
			switch(g_carstate)
			{
				case enSTOP: brake(0); break;	           //Сɲ
				case enRUN:	run(0);  break;	               //Сǰ				
				case enLEFT: left(0); break;		       //Сת
				case enRIGHT: right(0); break;	           //Сת
				case enBACK: back(0); break;		       //С
				case enUPLEFT: up_left(0); break;          //Сת
		    	case enUPRIGHT: up_right(0); break;        //Сת
		    	case enDOWNLEFT: down_left(0); break;      //Сת
		    	case enDOWNRIGHT: down_right(0); break;    //Сת
				case enSPINLEFT: spin_left(0); break;      //Сԭת
				case enSPINRIGHT: spin_right(0); break;    //Сԭת
				default: break;				    
			}
			g_oldcarstate= g_carstate;
		}

		//С״̬ӦĶ
		switch (g_ServoState)
        {
            case 0: if (flag != 0) 
					{
                    	flag = 0;
                    	servo_appointed_detection(90);
                    } 	
					break;

            case 1: if (flag != 1) 
					{
                    	flag = 1;
                    	servo_appointed_detection(180);
                    } 
					break;

            case 2: if (flag != 2) 
					{
                    	flag = 2;
                    	servo_appointed_detection(0);
					} 
					break;

            default: 
					break;
        }

		switch(g_volume)
		{
			case 1:
			printf("push_val_left = %d\n",push_val_left); 
			enMinMin();						   //Сٶ
			break;

			case 2:
			printf("push_val_left = %d\n",push_val_left);  
			enMin();							//Сٶ
			break;

			case 3:
			printf("push_val_left = %d\n",push_val_left);  
			enMidle();							//еٶ
			printf("PSB_l2_4_2 !\n");
			break;
										  
			case 4: 
			printf("push_val_left = %d\n",push_val_left); 
			enMax();							  //ٶ
			printf("PSB_l2_4_3 !\n");
			break;

			default:
			enMin();         //ĬСڽСٶȣҲǰõpush_val_left =10;   push_val_right=10; 
			break;
		}
		delay(50);   
	}	  
}